import{S as Lr,i as Gr,s as Br,e as o,k as c,w as u,t as n,M as zr,c as i,d as t,m as f,a as r,x as m,h as l,b as h,N as Vr,G as a,g as p,y as _,q as d,o as g,B as v,v as Hr}from"../../chunks/vendor-hf-doc-builder.js";import{T as Mr}from"../../chunks/Tip-hf-doc-builder.js";import{I as A}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as P}from"../../chunks/CodeBlock-hf-doc-builder.js";function Yr(at){let b,$,w,y,N;return{c(){b=o("p"),$=n("Dreambooth fine-tuning is very sensitive to hyperparameters and easy to overfit. We recommend you take a look at our "),w=o("a"),y=n("in-depth analysis"),N=n(" with recommended settings for different subjects, and go from there."),this.h()},l(E){b=i(E,"P",{});var S=r(b);$=l(S,"Dreambooth fine-tuning is very sensitive to hyperparameters and easy to overfit. We recommend you take a look at our "),w=i(S,"A",{href:!0,rel:!0});var Y=r(w);y=l(Y,"in-depth analysis"),Y.forEach(t),N=l(S," with recommended settings for different subjects, and go from there."),S.forEach(t),this.h()},h(){h(w,"href","https://huggingface.co/blog/dreambooth"),h(w,"rel","nofollow")},m(E,S){p(E,b,S),a(b,$),a(b,w),a(w,y),a(b,N)},d(E){E&&t(b)}}}function Fr(at){let b;return{c(){b=n("Training the text encoder requires additional memory, so training won't fit on a 16GB GPU. You'll need at least 24GB VRAM to use this option.")},l($){b=l($,"Training the text encoder requires additional memory, so training won't fit on a 16GB GPU. You'll need at least 24GB VRAM to use this option.")},m($,w){p($,b,w)},d($){$&&t(b)}}}function Wr(at){let b,$,w,y,N,E,S,Y,Es,aa,we,$e,ys,ks,sa,F,st,Ei,Ds,Ee,xs,ye,As,Ps,oa,W,Ss,ke,Ts,js,ia,J,ra,C,Z,mt,De,qs,_t,Is,na,R,K,dt,xe,Ns,gt,Cs,la,T,Rs,vt,Us,Os,bt,Ms,Ls,pa,Ae,ha,Q,Gs,Pe,Bs,zs,ca,Se,fa,j,Vs,wt,Hs,Ys,Te,Fs,Ws,ua,X,Js,$t,Zs,Ks,ma,U,ee,Et,je,Qs,yt,Xs,_a,te,eo,qe,to,ao,da,ot,so,ga,Ie,va,O,ae,kt,Ne,oo,Dt,io,ba,it,ro,wa,se,no,xt,lo,po,$a,Ce,Ea,M,oe,At,Re,ho,Pt,co,ya,rt,fo,ka,Ue,Da,k,uo,St,mo,_o,Tt,go,vo,jt,bo,wo,xa,L,ie,qt,Oe,$o,It,Eo,Aa,q,yo,Nt,ko,Do,Ct,xo,Ao,Pa,Me,Sa,nt,Po,Ta,G,re,Rt,Le,So,Ut,To,ja,lt,jo,qa,pt,qo,Ia,Ge,Na,B,ne,Ot,Be,Io,Mt,No,Ca,le,Co,ze,Ro,Uo,Ra,Ve,Ua,pe,Oo,Lt,Mo,Lo,Oa,He,Ma,z,he,Gt,Ye,Go,Bt,Bo,La,D,zo,zt,Vo,Ho,Vt,Yo,Fo,Fe,Wo,Jo,Ga,ce,Zo,Ht,Ko,Qo,Ba,fe,za,We,Va,V,ue,Yt,Je,Xo,Ft,ei,Ha,me,ti,Ze,ai,si,Ya,I,oi,Wt,ii,ri,Ke,ni,li,Fa,_e,pi,Jt,hi,ci,Wa,Qe,Ja,H,de,Zt,Xe,fi,Kt,ui,Za,x,mi,Qt,_i,di,Xt,gi,vi,ea,bi,wi,Ka,et,Qa;return E=new A({}),J=new Mr({props:{warning:!0,$$slots:{default:[Yr]},$$scope:{ctx:at}}}),De=new A({}),xe=new A({}),Ae=new P({props:{code:`pip install git+https://github.com/huggingface/diffusers
pip install -U -r diffusers/examples/dreambooth/requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers
pip install -U -r diffusers/examples/dreambooth/requirements.txt`}}),Se=new P({props:{code:"accelerate config",highlighted:"accelerate config"}}),je=new A({}),Ie=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --instance_prompt="a photo of sks dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --max_train_steps=400`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --max_train_steps=400`}}),Ne=new A({}),Ce=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),Re=new A({}),Ue=new P({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),Oe=new A({}),Me=new P({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),Le=new A({}),Ge=new P({props:{code:`from accelerate import Accelerator
from diffusers import DiffusionPipeline

# Load the pipeline with the same arguments (model, revision) that were used for training
model_id = "CompVis/stable-diffusion-v1-4"
pipeline = DiffusionPipeline.from_pretrained(model_id)

accelerator = Accelerator()

# Use text_encoder if \`--train_text_encoder\` was used for the initial training
unet, text_encoder = accelerator.prepare(pipeline.unet, pipeline.text_encoder)

# Restore state from a checkpoint path. You have to use the absolute path here.
accelerator.load_state("/sddata/dreambooth/daruma-v2-1/checkpoint-100")

# Rebuild the pipeline with the unwrapped models (assignment to .unet and .text_encoder should work too)
pipeline = DiffusionPipeline.from_pretrained(
    model_id,
    unet=accelerator.unwrap_model(unet),
    text_encoder=accelerator.unwrap_model(text_encoder),
)

# Perform inference, or save, or push to the hub
pipeline.save_pretrained("dreambooth-pipeline")`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-comment"># Load the pipeline with the same arguments (model, revision) that were used for training</span>
model_id = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
pipeline = DiffusionPipeline.from_pretrained(model_id)

accelerator = Accelerator()

<span class="hljs-comment"># Use text_encoder if \`--train_text_encoder\` was used for the initial training</span>
unet, text_encoder = accelerator.prepare(pipeline.unet, pipeline.text_encoder)

<span class="hljs-comment"># Restore state from a checkpoint path. You have to use the absolute path here.</span>
accelerator.load_state(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100&quot;</span>)

<span class="hljs-comment"># Rebuild the pipeline with the unwrapped models (assignment to .unet and .text_encoder should work too)</span>
pipeline = DiffusionPipeline.from_pretrained(
    model_id,
    unet=accelerator.unwrap_model(unet),
    text_encoder=accelerator.unwrap_model(text_encoder),
)

<span class="hljs-comment"># Perform inference, or save, or push to the hub</span>
pipeline.save_pretrained(<span class="hljs-string">&quot;dreambooth-pipeline&quot;</span>)`}}),Be=new A({}),Ve=new P({props:{code:"pip install bitsandbytes",highlighted:"pip install bitsandbytes"}}),He=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=2 --gradient_checkpointing \\
  --use_8bit_adam \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=2 --gradient_checkpointing \\
  --use_8bit_adam \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),Ye=new A({}),fe=new Mr({props:{$$slots:{default:[Fr]},$$scope:{ctx:at}}}),We=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --train_text_encoder \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --use_8bit_adam
  --gradient_checkpointing \\
  --learning_rate=2e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --train_text_encoder \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --use_8bit_adam
  --gradient_checkpointing \\
  --learning_rate=2e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),Je=new A({}),Qe=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --sample_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --mixed_precision=fp16`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --sample_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --mixed_precision=fp16`}}),Xe=new A({}),et=new P({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "path_to_saved_model"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

prompt = "A photo of sks dog in a bucket"
image = pipe(prompt, num_inference_steps=50, guidance_scale=7.5).images[0]

image.save("dog-bucket.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;A photo of sks dog in a bucket&quot;</span>
image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>, guidance_scale=<span class="hljs-number">7.5</span>).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;dog-bucket.png&quot;</span>)`}}),{c(){b=o("meta"),$=c(),w=o("h1"),y=o("a"),N=o("span"),u(E.$$.fragment),S=c(),Y=o("span"),Es=n("DreamBooth fine-tuning example"),aa=c(),we=o("p"),$e=o("a"),ys=n("DreamBooth"),ks=n(" is a method to personalize text-to-image models like stable diffusion given just a few (3~5) images of a subject."),sa=c(),F=o("p"),st=o("img"),Ds=c(),Ee=o("em"),xs=n("Dreambooth examples from the "),ye=o("a"),As=n("project\u2019s blog"),Ps=n("."),oa=c(),W=o("p"),Ss=n("The "),ke=o("a"),Ts=n("Dreambooth training script"),js=n(" shows how to implement this training procedure on a pre-trained Stable Diffusion model."),ia=c(),u(J.$$.fragment),ra=c(),C=o("h2"),Z=o("a"),mt=o("span"),u(De.$$.fragment),qs=c(),_t=o("span"),Is=n("Training locally"),na=c(),R=o("h3"),K=o("a"),dt=o("span"),u(xe.$$.fragment),Ns=c(),gt=o("span"),Cs=n("Installing the dependencies"),la=c(),T=o("p"),Rs=n("Before running the scripts, make sure to install the library\u2019s training dependencies. We also recommend to install "),vt=o("code"),Us=n("diffusers"),Os=n(" from the "),bt=o("code"),Ms=n("main"),Ls=n(" github branch."),pa=c(),u(Ae.$$.fragment),ha=c(),Q=o("p"),Gs=n("Then initialize and configure a "),Pe=o("a"),Bs=n("\u{1F917} Accelerate"),zs=n(" environment with:"),ca=c(),u(Se.$$.fragment),fa=c(),j=o("p"),Vs=n("In this example we\u2019ll use model version "),wt=o("code"),Hs=n("v1-4"),Ys=n(", so please visit "),Te=o("a"),Fs=n("its card"),Ws=n(" and carefully read the license before proceeding."),ua=c(),X=o("p"),Js=n("The command below will download and cache the model weights from the Hub because we use the model\u2019s Hub id "),$t=o("code"),Zs=n("CompVis/stable-diffusion-v1-4"),Ks=n(". You may also clone the repo locally and use the local path in your system where the checkout was saved."),ma=c(),U=o("h3"),ee=o("a"),Et=o("span"),u(je.$$.fragment),Qs=c(),yt=o("span"),Xs=n("Dog toy example"),_a=c(),te=o("p"),eo=n("In this example we\u2019ll use "),qe=o("a"),to=n("these images"),ao=n(" to add a new concept to Stable Diffusion using the Dreambooth process. They will be our training data. Please, download them and place them somewhere in your system."),da=c(),ot=o("p"),so=n("Then you can launch the training script using:"),ga=c(),u(Ie.$$.fragment),va=c(),O=o("h3"),ae=o("a"),kt=o("span"),u(Ne.$$.fragment),oo=c(),Dt=o("span"),io=n("Training with a prior-preserving loss"),ba=c(),it=o("p"),ro=n("Prior preservation is used to avoid overfitting and language-drift. Please, refer to the paper to learn more about it if you are interested. For prior preservation, we use other images of the same class as part of the training process. The nice thing is that we can generate those images using the Stable Diffusion model itself! The training script will save the generated images to a local path we specify."),wa=c(),se=o("p"),no=n("According to the paper, it\u2019s recommended to generate "),xt=o("code"),lo=n("num_epochs * num_samples"),po=n(" images for prior preservation. 200-300 works well for most cases."),$a=c(),u(Ce.$$.fragment),Ea=c(),M=o("h3"),oe=o("a"),At=o("span"),u(Re.$$.fragment),ho=c(),Pt=o("span"),co=n("Saving checkpoints while training"),ya=c(),rt=o("p"),fo=n("It\u2019s easy to overfit while training with Dreambooth, so sometimes it\u2019s useful to save regular checkpoints during the process. One of the intermediate checkpoints might work better than the final model! To use this feature you need to pass the following argument to the training script:"),ka=c(),u(Ue.$$.fragment),Da=c(),k=o("p"),uo=n("This will save the full training state in subfolders of your "),St=o("code"),mo=n("output_dir"),_o=n(". Subfolder names begin with the prefix "),Tt=o("code"),go=n("checkpoint-"),vo=n(", and then the number of steps performed so far; for example: "),jt=o("code"),bo=n("checkpoint-1500"),wo=n(" would be a checkpoint saved after 1500 training steps."),xa=c(),L=o("h4"),ie=o("a"),qt=o("span"),u(Oe.$$.fragment),$o=c(),It=o("span"),Eo=n("Resuming training from a saved checkpoint"),Aa=c(),q=o("p"),yo=n("If you want to resume training from any of the saved checkpoints, you can pass the argument "),Nt=o("code"),ko=n("--resume_from_checkpoint"),Do=n(" and then indicate the name of the checkpoint you want to use. You can also use the special string "),Ct=o("code"),xo=n('"latest"'),Ao=n(" to resume from the last checkpoint saved (i.e., the one with the largest number of steps). For example, the following would resume training from the checkpoint saved after 1500 steps:"),Pa=c(),u(Me.$$.fragment),Sa=c(),nt=o("p"),Po=n("This would be a good opportunity to tweak some of your hyperparameters if you wish."),Ta=c(),G=o("h4"),re=o("a"),Rt=o("span"),u(Le.$$.fragment),So=c(),Ut=o("span"),To=n("Performing inference using a saved checkpoint"),ja=c(),lt=o("p"),jo=n("Saved checkpoints are stored in a format suitable for resuming training. They not only include the model weights, but also the state of the optimizer, data loaders and learning rate."),qa=c(),pt=o("p"),qo=n("You can use a checkpoint for inference, but first you need to convert it to an inference pipeline. This is how you could do it:"),Ia=c(),u(Ge.$$.fragment),Na=c(),B=o("h3"),ne=o("a"),Ot=o("span"),u(Be.$$.fragment),Io=c(),Mt=o("span"),No=n("Training on a 16GB GPU"),Ca=c(),le=o("p"),Co=n("With the help of gradient checkpointing and the 8-bit optimizer from "),ze=o("a"),Ro=n("bitsandbytes"),Uo=n(", it\u2019s possible to train dreambooth on a 16GB GPU."),Ra=c(),u(Ve.$$.fragment),Ua=c(),pe=o("p"),Oo=n("Then pass the "),Lt=o("code"),Mo=n("--use_8bit_adam"),Lo=n(" option to the training script."),Oa=c(),u(He.$$.fragment),Ma=c(),z=o("h3"),he=o("a"),Gt=o("span"),u(Ye.$$.fragment),Go=c(),Bt=o("span"),Bo=n("Fine-tune the text encoder in addition to the UNet"),La=c(),D=o("p"),zo=n("The script also allows to fine-tune the "),zt=o("code"),Vo=n("text_encoder"),Ho=n(" along with the "),Vt=o("code"),Yo=n("unet"),Fo=n(". It has been observed experimentally that this gives much better results, especially on faces. Please, refer to "),Fe=o("a"),Wo=n("our blog"),Jo=n(" for more details."),Ga=c(),ce=o("p"),Zo=n("To enable this option, pass the "),Ht=o("code"),Ko=n("--train_text_encoder"),Qo=n(" argument to the training script."),Ba=c(),u(fe.$$.fragment),za=c(),u(We.$$.fragment),Va=c(),V=o("h3"),ue=o("a"),Yt=o("span"),u(Je.$$.fragment),Xo=c(),Ft=o("span"),ei=n("Training on a 8 GB GPU:"),Ha=c(),me=o("p"),ti=n("Using "),Ze=o("a"),ai=n("DeepSpeed"),si=n(` it\u2019s even possible to offload some
tensors from VRAM to either CPU or NVME, allowing training to proceed with less GPU memory.`),Ya=c(),I=o("p"),oi=n("DeepSpeed needs to be enabled with "),Wt=o("code"),ii=n("accelerate config"),ri=n(`. During configuration,
answer yes to \u201CDo you want to use DeepSpeed?\u201C. Combining DeepSpeed stage 2, fp16
mixed precision, and offloading both the model parameters and the optimizer state to CPU, it\u2019s
possible to train on under 8 GB VRAM. The drawback is that this requires more system RAM (about 25 GB). See `),Ke=o("a"),ni=n("the DeepSpeed documentation"),li=n(" for more configuration options."),Fa=c(),_e=o("p"),pi=n(`Changing the default Adam optimizer to DeepSpeed\u2019s special version of Adam
`),Jt=o("code"),hi=n("deepspeed.ops.adam.DeepSpeedCPUAdam"),ci=n(` gives a substantial speedup, but enabling
it requires the system\u2019s CUDA toolchain version to be the same as the one installed with PyTorch. 8-bit optimizers don\u2019t seem to be compatible with DeepSpeed at the moment.`),Wa=c(),u(Qe.$$.fragment),Ja=c(),H=o("h2"),de=o("a"),Zt=o("span"),u(Xe.$$.fragment),fi=c(),Kt=o("span"),ui=n("Inference"),Za=c(),x=o("p"),mi=n("Once you have trained a model, inference can be done using the "),Qt=o("code"),_i=n("StableDiffusionPipeline"),di=n(", by simply indicating the path where the model was saved. Make sure that your prompts include the special "),Xt=o("code"),gi=n("identifier"),vi=n(" used during training ("),ea=o("code"),bi=n("sks"),wi=n(" in the previous examples)."),Ka=c(),u(et.$$.fragment),this.h()},l(e){const s=zr('[data-svelte="svelte-1phssyn"]',document.head);b=i(s,"META",{name:!0,content:!0}),s.forEach(t),$=f(e),w=i(e,"H1",{class:!0});var tt=r(w);y=i(tt,"A",{id:!0,class:!0,href:!0});var ta=r(y);N=i(ta,"SPAN",{});var yi=r(N);m(E.$$.fragment,yi),yi.forEach(t),ta.forEach(t),S=f(tt),Y=i(tt,"SPAN",{});var ki=r(Y);Es=l(ki,"DreamBooth fine-tuning example"),ki.forEach(t),tt.forEach(t),aa=f(e),we=i(e,"P",{});var $i=r(we);$e=i($i,"A",{href:!0,rel:!0});var Di=r($e);ys=l(Di,"DreamBooth"),Di.forEach(t),ks=l($i," is a method to personalize text-to-image models like stable diffusion given just a few (3~5) images of a subject."),$i.forEach(t),sa=f(e),F=i(e,"P",{});var Xa=r(F);st=i(Xa,"IMG",{src:!0,alt:!0}),Ds=f(Xa),Ee=i(Xa,"EM",{});var es=r(Ee);xs=l(es,"Dreambooth examples from the "),ye=i(es,"A",{href:!0,rel:!0});var xi=r(ye);As=l(xi,"project\u2019s blog"),xi.forEach(t),Ps=l(es,"."),es.forEach(t),Xa.forEach(t),oa=f(e),W=i(e,"P",{});var ts=r(W);Ss=l(ts,"The "),ke=i(ts,"A",{href:!0,rel:!0});var Ai=r(ke);Ts=l(Ai,"Dreambooth training script"),Ai.forEach(t),js=l(ts," shows how to implement this training procedure on a pre-trained Stable Diffusion model."),ts.forEach(t),ia=f(e),m(J.$$.fragment,e),ra=f(e),C=i(e,"H2",{class:!0});var as=r(C);Z=i(as,"A",{id:!0,class:!0,href:!0});var Pi=r(Z);mt=i(Pi,"SPAN",{});var Si=r(mt);m(De.$$.fragment,Si),Si.forEach(t),Pi.forEach(t),qs=f(as),_t=i(as,"SPAN",{});var Ti=r(_t);Is=l(Ti,"Training locally"),Ti.forEach(t),as.forEach(t),na=f(e),R=i(e,"H3",{class:!0});var ss=r(R);K=i(ss,"A",{id:!0,class:!0,href:!0});var ji=r(K);dt=i(ji,"SPAN",{});var qi=r(dt);m(xe.$$.fragment,qi),qi.forEach(t),ji.forEach(t),Ns=f(ss),gt=i(ss,"SPAN",{});var Ii=r(gt);Cs=l(Ii,"Installing the dependencies"),Ii.forEach(t),ss.forEach(t),la=f(e),T=i(e,"P",{});var ht=r(T);Rs=l(ht,"Before running the scripts, make sure to install the library\u2019s training dependencies. We also recommend to install "),vt=i(ht,"CODE",{});var Ni=r(vt);Us=l(Ni,"diffusers"),Ni.forEach(t),Os=l(ht," from the "),bt=i(ht,"CODE",{});var Ci=r(bt);Ms=l(Ci,"main"),Ci.forEach(t),Ls=l(ht," github branch."),ht.forEach(t),pa=f(e),m(Ae.$$.fragment,e),ha=f(e),Q=i(e,"P",{});var os=r(Q);Gs=l(os,"Then initialize and configure a "),Pe=i(os,"A",{href:!0,rel:!0});var Ri=r(Pe);Bs=l(Ri,"\u{1F917} Accelerate"),Ri.forEach(t),zs=l(os," environment with:"),os.forEach(t),ca=f(e),m(Se.$$.fragment,e),fa=f(e),j=i(e,"P",{});var ct=r(j);Vs=l(ct,"In this example we\u2019ll use model version "),wt=i(ct,"CODE",{});var Ui=r(wt);Hs=l(Ui,"v1-4"),Ui.forEach(t),Ys=l(ct,", so please visit "),Te=i(ct,"A",{href:!0,rel:!0});var Oi=r(Te);Fs=l(Oi,"its card"),Oi.forEach(t),Ws=l(ct," and carefully read the license before proceeding."),ct.forEach(t),ua=f(e),X=i(e,"P",{});var is=r(X);Js=l(is,"The command below will download and cache the model weights from the Hub because we use the model\u2019s Hub id "),$t=i(is,"CODE",{});var Mi=r($t);Zs=l(Mi,"CompVis/stable-diffusion-v1-4"),Mi.forEach(t),Ks=l(is,". You may also clone the repo locally and use the local path in your system where the checkout was saved."),is.forEach(t),ma=f(e),U=i(e,"H3",{class:!0});var rs=r(U);ee=i(rs,"A",{id:!0,class:!0,href:!0});var Li=r(ee);Et=i(Li,"SPAN",{});var Gi=r(Et);m(je.$$.fragment,Gi),Gi.forEach(t),Li.forEach(t),Qs=f(rs),yt=i(rs,"SPAN",{});var Bi=r(yt);Xs=l(Bi,"Dog toy example"),Bi.forEach(t),rs.forEach(t),_a=f(e),te=i(e,"P",{});var ns=r(te);eo=l(ns,"In this example we\u2019ll use "),qe=i(ns,"A",{href:!0,rel:!0});var zi=r(qe);to=l(zi,"these images"),zi.forEach(t),ao=l(ns," to add a new concept to Stable Diffusion using the Dreambooth process. They will be our training data. Please, download them and place them somewhere in your system."),ns.forEach(t),da=f(e),ot=i(e,"P",{});var Vi=r(ot);so=l(Vi,"Then you can launch the training script using:"),Vi.forEach(t),ga=f(e),m(Ie.$$.fragment,e),va=f(e),O=i(e,"H3",{class:!0});var ls=r(O);ae=i(ls,"A",{id:!0,class:!0,href:!0});var Hi=r(ae);kt=i(Hi,"SPAN",{});var Yi=r(kt);m(Ne.$$.fragment,Yi),Yi.forEach(t),Hi.forEach(t),oo=f(ls),Dt=i(ls,"SPAN",{});var Fi=r(Dt);io=l(Fi,"Training with a prior-preserving loss"),Fi.forEach(t),ls.forEach(t),ba=f(e),it=i(e,"P",{});var Wi=r(it);ro=l(Wi,"Prior preservation is used to avoid overfitting and language-drift. Please, refer to the paper to learn more about it if you are interested. For prior preservation, we use other images of the same class as part of the training process. The nice thing is that we can generate those images using the Stable Diffusion model itself! The training script will save the generated images to a local path we specify."),Wi.forEach(t),wa=f(e),se=i(e,"P",{});var ps=r(se);no=l(ps,"According to the paper, it\u2019s recommended to generate "),xt=i(ps,"CODE",{});var Ji=r(xt);lo=l(Ji,"num_epochs * num_samples"),Ji.forEach(t),po=l(ps," images for prior preservation. 200-300 works well for most cases."),ps.forEach(t),$a=f(e),m(Ce.$$.fragment,e),Ea=f(e),M=i(e,"H3",{class:!0});var hs=r(M);oe=i(hs,"A",{id:!0,class:!0,href:!0});var Zi=r(oe);At=i(Zi,"SPAN",{});var Ki=r(At);m(Re.$$.fragment,Ki),Ki.forEach(t),Zi.forEach(t),ho=f(hs),Pt=i(hs,"SPAN",{});var Qi=r(Pt);co=l(Qi,"Saving checkpoints while training"),Qi.forEach(t),hs.forEach(t),ya=f(e),rt=i(e,"P",{});var Xi=r(rt);fo=l(Xi,"It\u2019s easy to overfit while training with Dreambooth, so sometimes it\u2019s useful to save regular checkpoints during the process. One of the intermediate checkpoints might work better than the final model! To use this feature you need to pass the following argument to the training script:"),Xi.forEach(t),ka=f(e),m(Ue.$$.fragment,e),Da=f(e),k=i(e,"P",{});var ge=r(k);uo=l(ge,"This will save the full training state in subfolders of your "),St=i(ge,"CODE",{});var er=r(St);mo=l(er,"output_dir"),er.forEach(t),_o=l(ge,". Subfolder names begin with the prefix "),Tt=i(ge,"CODE",{});var tr=r(Tt);go=l(tr,"checkpoint-"),tr.forEach(t),vo=l(ge,", and then the number of steps performed so far; for example: "),jt=i(ge,"CODE",{});var ar=r(jt);bo=l(ar,"checkpoint-1500"),ar.forEach(t),wo=l(ge," would be a checkpoint saved after 1500 training steps."),ge.forEach(t),xa=f(e),L=i(e,"H4",{class:!0});var cs=r(L);ie=i(cs,"A",{id:!0,class:!0,href:!0});var sr=r(ie);qt=i(sr,"SPAN",{});var or=r(qt);m(Oe.$$.fragment,or),or.forEach(t),sr.forEach(t),$o=f(cs),It=i(cs,"SPAN",{});var ir=r(It);Eo=l(ir,"Resuming training from a saved checkpoint"),ir.forEach(t),cs.forEach(t),Aa=f(e),q=i(e,"P",{});var ft=r(q);yo=l(ft,"If you want to resume training from any of the saved checkpoints, you can pass the argument "),Nt=i(ft,"CODE",{});var rr=r(Nt);ko=l(rr,"--resume_from_checkpoint"),rr.forEach(t),Do=l(ft," and then indicate the name of the checkpoint you want to use. You can also use the special string "),Ct=i(ft,"CODE",{});var nr=r(Ct);xo=l(nr,'"latest"'),nr.forEach(t),Ao=l(ft," to resume from the last checkpoint saved (i.e., the one with the largest number of steps). For example, the following would resume training from the checkpoint saved after 1500 steps:"),ft.forEach(t),Pa=f(e),m(Me.$$.fragment,e),Sa=f(e),nt=i(e,"P",{});var lr=r(nt);Po=l(lr,"This would be a good opportunity to tweak some of your hyperparameters if you wish."),lr.forEach(t),Ta=f(e),G=i(e,"H4",{class:!0});var fs=r(G);re=i(fs,"A",{id:!0,class:!0,href:!0});var pr=r(re);Rt=i(pr,"SPAN",{});var hr=r(Rt);m(Le.$$.fragment,hr),hr.forEach(t),pr.forEach(t),So=f(fs),Ut=i(fs,"SPAN",{});var cr=r(Ut);To=l(cr,"Performing inference using a saved checkpoint"),cr.forEach(t),fs.forEach(t),ja=f(e),lt=i(e,"P",{});var fr=r(lt);jo=l(fr,"Saved checkpoints are stored in a format suitable for resuming training. They not only include the model weights, but also the state of the optimizer, data loaders and learning rate."),fr.forEach(t),qa=f(e),pt=i(e,"P",{});var ur=r(pt);qo=l(ur,"You can use a checkpoint for inference, but first you need to convert it to an inference pipeline. This is how you could do it:"),ur.forEach(t),Ia=f(e),m(Ge.$$.fragment,e),Na=f(e),B=i(e,"H3",{class:!0});var us=r(B);ne=i(us,"A",{id:!0,class:!0,href:!0});var mr=r(ne);Ot=i(mr,"SPAN",{});var _r=r(Ot);m(Be.$$.fragment,_r),_r.forEach(t),mr.forEach(t),Io=f(us),Mt=i(us,"SPAN",{});var dr=r(Mt);No=l(dr,"Training on a 16GB GPU"),dr.forEach(t),us.forEach(t),Ca=f(e),le=i(e,"P",{});var ms=r(le);Co=l(ms,"With the help of gradient checkpointing and the 8-bit optimizer from "),ze=i(ms,"A",{href:!0,rel:!0});var gr=r(ze);Ro=l(gr,"bitsandbytes"),gr.forEach(t),Uo=l(ms,", it\u2019s possible to train dreambooth on a 16GB GPU."),ms.forEach(t),Ra=f(e),m(Ve.$$.fragment,e),Ua=f(e),pe=i(e,"P",{});var _s=r(pe);Oo=l(_s,"Then pass the "),Lt=i(_s,"CODE",{});var vr=r(Lt);Mo=l(vr,"--use_8bit_adam"),vr.forEach(t),Lo=l(_s," option to the training script."),_s.forEach(t),Oa=f(e),m(He.$$.fragment,e),Ma=f(e),z=i(e,"H3",{class:!0});var ds=r(z);he=i(ds,"A",{id:!0,class:!0,href:!0});var br=r(he);Gt=i(br,"SPAN",{});var wr=r(Gt);m(Ye.$$.fragment,wr),wr.forEach(t),br.forEach(t),Go=f(ds),Bt=i(ds,"SPAN",{});var $r=r(Bt);Bo=l($r,"Fine-tune the text encoder in addition to the UNet"),$r.forEach(t),ds.forEach(t),La=f(e),D=i(e,"P",{});var ve=r(D);zo=l(ve,"The script also allows to fine-tune the "),zt=i(ve,"CODE",{});var Er=r(zt);Vo=l(Er,"text_encoder"),Er.forEach(t),Ho=l(ve," along with the "),Vt=i(ve,"CODE",{});var yr=r(Vt);Yo=l(yr,"unet"),yr.forEach(t),Fo=l(ve,". It has been observed experimentally that this gives much better results, especially on faces. Please, refer to "),Fe=i(ve,"A",{href:!0,rel:!0});var kr=r(Fe);Wo=l(kr,"our blog"),kr.forEach(t),Jo=l(ve," for more details."),ve.forEach(t),Ga=f(e),ce=i(e,"P",{});var gs=r(ce);Zo=l(gs,"To enable this option, pass the "),Ht=i(gs,"CODE",{});var Dr=r(Ht);Ko=l(Dr,"--train_text_encoder"),Dr.forEach(t),Qo=l(gs," argument to the training script."),gs.forEach(t),Ba=f(e),m(fe.$$.fragment,e),za=f(e),m(We.$$.fragment,e),Va=f(e),V=i(e,"H3",{class:!0});var vs=r(V);ue=i(vs,"A",{id:!0,class:!0,href:!0});var xr=r(ue);Yt=i(xr,"SPAN",{});var Ar=r(Yt);m(Je.$$.fragment,Ar),Ar.forEach(t),xr.forEach(t),Xo=f(vs),Ft=i(vs,"SPAN",{});var Pr=r(Ft);ei=l(Pr,"Training on a 8 GB GPU:"),Pr.forEach(t),vs.forEach(t),Ha=f(e),me=i(e,"P",{});var bs=r(me);ti=l(bs,"Using "),Ze=i(bs,"A",{href:!0,rel:!0});var Sr=r(Ze);ai=l(Sr,"DeepSpeed"),Sr.forEach(t),si=l(bs,` it\u2019s even possible to offload some
tensors from VRAM to either CPU or NVME, allowing training to proceed with less GPU memory.`),bs.forEach(t),Ya=f(e),I=i(e,"P",{});var ut=r(I);oi=l(ut,"DeepSpeed needs to be enabled with "),Wt=i(ut,"CODE",{});var Tr=r(Wt);ii=l(Tr,"accelerate config"),Tr.forEach(t),ri=l(ut,`. During configuration,
answer yes to \u201CDo you want to use DeepSpeed?\u201C. Combining DeepSpeed stage 2, fp16
mixed precision, and offloading both the model parameters and the optimizer state to CPU, it\u2019s
possible to train on under 8 GB VRAM. The drawback is that this requires more system RAM (about 25 GB). See `),Ke=i(ut,"A",{href:!0,rel:!0});var jr=r(Ke);ni=l(jr,"the DeepSpeed documentation"),jr.forEach(t),li=l(ut," for more configuration options."),ut.forEach(t),Fa=f(e),_e=i(e,"P",{});var ws=r(_e);pi=l(ws,`Changing the default Adam optimizer to DeepSpeed\u2019s special version of Adam
`),Jt=i(ws,"CODE",{});var qr=r(Jt);hi=l(qr,"deepspeed.ops.adam.DeepSpeedCPUAdam"),qr.forEach(t),ci=l(ws,` gives a substantial speedup, but enabling
it requires the system\u2019s CUDA toolchain version to be the same as the one installed with PyTorch. 8-bit optimizers don\u2019t seem to be compatible with DeepSpeed at the moment.`),ws.forEach(t),Wa=f(e),m(Qe.$$.fragment,e),Ja=f(e),H=i(e,"H2",{class:!0});var $s=r(H);de=i($s,"A",{id:!0,class:!0,href:!0});var Ir=r(de);Zt=i(Ir,"SPAN",{});var Nr=r(Zt);m(Xe.$$.fragment,Nr),Nr.forEach(t),Ir.forEach(t),fi=f($s),Kt=i($s,"SPAN",{});var Cr=r(Kt);ui=l(Cr,"Inference"),Cr.forEach(t),$s.forEach(t),Za=f(e),x=i(e,"P",{});var be=r(x);mi=l(be,"Once you have trained a model, inference can be done using the "),Qt=i(be,"CODE",{});var Rr=r(Qt);_i=l(Rr,"StableDiffusionPipeline"),Rr.forEach(t),di=l(be,", by simply indicating the path where the model was saved. Make sure that your prompts include the special "),Xt=i(be,"CODE",{});var Ur=r(Xt);gi=l(Ur,"identifier"),Ur.forEach(t),vi=l(be," used during training ("),ea=i(be,"CODE",{});var Or=r(ea);bi=l(Or,"sks"),Or.forEach(t),wi=l(be," in the previous examples)."),be.forEach(t),Ka=f(e),m(et.$$.fragment,e),this.h()},h(){h(b,"name","hf:doc:metadata"),h(b,"content",JSON.stringify(Jr)),h(y,"id","dreambooth-finetuning-example"),h(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(y,"href","#dreambooth-finetuning-example"),h(w,"class","relative group"),h($e,"href","https://arxiv.org/abs/2208.12242"),h($e,"rel","nofollow"),Vr(st.src,Ei="https://dreambooth.github.io/DreamBooth_files/teaser_static.jpg")||h(st,"src",Ei),h(st,"alt","Dreambooth examples from the project's blog"),h(ye,"href","https://dreambooth.github.io"),h(ye,"rel","nofollow"),h(ke,"href","https://github.com/huggingface/diffusers/tree/main/examples/dreambooth"),h(ke,"rel","nofollow"),h(Z,"id","training-locally"),h(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Z,"href","#training-locally"),h(C,"class","relative group"),h(K,"id","installing-the-dependencies"),h(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(K,"href","#installing-the-dependencies"),h(R,"class","relative group"),h(Pe,"href","https://github.com/huggingface/accelerate/"),h(Pe,"rel","nofollow"),h(Te,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),h(Te,"rel","nofollow"),h(ee,"id","dog-toy-example"),h(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ee,"href","#dog-toy-example"),h(U,"class","relative group"),h(qe,"href","https://drive.google.com/drive/folders/1BO_dyz-p65qhBRRMRA4TbZ8qW4rB99JZ"),h(qe,"rel","nofollow"),h(ae,"id","training-with-a-priorpreserving-loss"),h(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ae,"href","#training-with-a-priorpreserving-loss"),h(O,"class","relative group"),h(oe,"id","saving-checkpoints-while-training"),h(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(oe,"href","#saving-checkpoints-while-training"),h(M,"class","relative group"),h(ie,"id","resuming-training-from-a-saved-checkpoint"),h(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ie,"href","#resuming-training-from-a-saved-checkpoint"),h(L,"class","relative group"),h(re,"id","performing-inference-using-a-saved-checkpoint"),h(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(re,"href","#performing-inference-using-a-saved-checkpoint"),h(G,"class","relative group"),h(ne,"id","training-on-a-16gb-gpu"),h(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ne,"href","#training-on-a-16gb-gpu"),h(B,"class","relative group"),h(ze,"href","https://github.com/TimDettmers/bitsandbytes"),h(ze,"rel","nofollow"),h(he,"id","finetune-the-text-encoder-in-addition-to-the-unet"),h(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(he,"href","#finetune-the-text-encoder-in-addition-to-the-unet"),h(z,"class","relative group"),h(Fe,"href","https://huggingface.co/blog/dreambooth"),h(Fe,"rel","nofollow"),h(ue,"id","training-on-a-8-gb-gpu"),h(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ue,"href","#training-on-a-8-gb-gpu"),h(V,"class","relative group"),h(Ze,"href","https://www.deepspeed.ai/"),h(Ze,"rel","nofollow"),h(Ke,"href","https://huggingface.co/docs/accelerate/usage_guides/deepspeed"),h(Ke,"rel","nofollow"),h(de,"id","inference"),h(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(de,"href","#inference"),h(H,"class","relative group")},m(e,s){a(document.head,b),p(e,$,s),p(e,w,s),a(w,y),a(y,N),_(E,N,null),a(w,S),a(w,Y),a(Y,Es),p(e,aa,s),p(e,we,s),a(we,$e),a($e,ys),a(we,ks),p(e,sa,s),p(e,F,s),a(F,st),a(F,Ds),a(F,Ee),a(Ee,xs),a(Ee,ye),a(ye,As),a(Ee,Ps),p(e,oa,s),p(e,W,s),a(W,Ss),a(W,ke),a(ke,Ts),a(W,js),p(e,ia,s),_(J,e,s),p(e,ra,s),p(e,C,s),a(C,Z),a(Z,mt),_(De,mt,null),a(C,qs),a(C,_t),a(_t,Is),p(e,na,s),p(e,R,s),a(R,K),a(K,dt),_(xe,dt,null),a(R,Ns),a(R,gt),a(gt,Cs),p(e,la,s),p(e,T,s),a(T,Rs),a(T,vt),a(vt,Us),a(T,Os),a(T,bt),a(bt,Ms),a(T,Ls),p(e,pa,s),_(Ae,e,s),p(e,ha,s),p(e,Q,s),a(Q,Gs),a(Q,Pe),a(Pe,Bs),a(Q,zs),p(e,ca,s),_(Se,e,s),p(e,fa,s),p(e,j,s),a(j,Vs),a(j,wt),a(wt,Hs),a(j,Ys),a(j,Te),a(Te,Fs),a(j,Ws),p(e,ua,s),p(e,X,s),a(X,Js),a(X,$t),a($t,Zs),a(X,Ks),p(e,ma,s),p(e,U,s),a(U,ee),a(ee,Et),_(je,Et,null),a(U,Qs),a(U,yt),a(yt,Xs),p(e,_a,s),p(e,te,s),a(te,eo),a(te,qe),a(qe,to),a(te,ao),p(e,da,s),p(e,ot,s),a(ot,so),p(e,ga,s),_(Ie,e,s),p(e,va,s),p(e,O,s),a(O,ae),a(ae,kt),_(Ne,kt,null),a(O,oo),a(O,Dt),a(Dt,io),p(e,ba,s),p(e,it,s),a(it,ro),p(e,wa,s),p(e,se,s),a(se,no),a(se,xt),a(xt,lo),a(se,po),p(e,$a,s),_(Ce,e,s),p(e,Ea,s),p(e,M,s),a(M,oe),a(oe,At),_(Re,At,null),a(M,ho),a(M,Pt),a(Pt,co),p(e,ya,s),p(e,rt,s),a(rt,fo),p(e,ka,s),_(Ue,e,s),p(e,Da,s),p(e,k,s),a(k,uo),a(k,St),a(St,mo),a(k,_o),a(k,Tt),a(Tt,go),a(k,vo),a(k,jt),a(jt,bo),a(k,wo),p(e,xa,s),p(e,L,s),a(L,ie),a(ie,qt),_(Oe,qt,null),a(L,$o),a(L,It),a(It,Eo),p(e,Aa,s),p(e,q,s),a(q,yo),a(q,Nt),a(Nt,ko),a(q,Do),a(q,Ct),a(Ct,xo),a(q,Ao),p(e,Pa,s),_(Me,e,s),p(e,Sa,s),p(e,nt,s),a(nt,Po),p(e,Ta,s),p(e,G,s),a(G,re),a(re,Rt),_(Le,Rt,null),a(G,So),a(G,Ut),a(Ut,To),p(e,ja,s),p(e,lt,s),a(lt,jo),p(e,qa,s),p(e,pt,s),a(pt,qo),p(e,Ia,s),_(Ge,e,s),p(e,Na,s),p(e,B,s),a(B,ne),a(ne,Ot),_(Be,Ot,null),a(B,Io),a(B,Mt),a(Mt,No),p(e,Ca,s),p(e,le,s),a(le,Co),a(le,ze),a(ze,Ro),a(le,Uo),p(e,Ra,s),_(Ve,e,s),p(e,Ua,s),p(e,pe,s),a(pe,Oo),a(pe,Lt),a(Lt,Mo),a(pe,Lo),p(e,Oa,s),_(He,e,s),p(e,Ma,s),p(e,z,s),a(z,he),a(he,Gt),_(Ye,Gt,null),a(z,Go),a(z,Bt),a(Bt,Bo),p(e,La,s),p(e,D,s),a(D,zo),a(D,zt),a(zt,Vo),a(D,Ho),a(D,Vt),a(Vt,Yo),a(D,Fo),a(D,Fe),a(Fe,Wo),a(D,Jo),p(e,Ga,s),p(e,ce,s),a(ce,Zo),a(ce,Ht),a(Ht,Ko),a(ce,Qo),p(e,Ba,s),_(fe,e,s),p(e,za,s),_(We,e,s),p(e,Va,s),p(e,V,s),a(V,ue),a(ue,Yt),_(Je,Yt,null),a(V,Xo),a(V,Ft),a(Ft,ei),p(e,Ha,s),p(e,me,s),a(me,ti),a(me,Ze),a(Ze,ai),a(me,si),p(e,Ya,s),p(e,I,s),a(I,oi),a(I,Wt),a(Wt,ii),a(I,ri),a(I,Ke),a(Ke,ni),a(I,li),p(e,Fa,s),p(e,_e,s),a(_e,pi),a(_e,Jt),a(Jt,hi),a(_e,ci),p(e,Wa,s),_(Qe,e,s),p(e,Ja,s),p(e,H,s),a(H,de),a(de,Zt),_(Xe,Zt,null),a(H,fi),a(H,Kt),a(Kt,ui),p(e,Za,s),p(e,x,s),a(x,mi),a(x,Qt),a(Qt,_i),a(x,di),a(x,Xt),a(Xt,gi),a(x,vi),a(x,ea),a(ea,bi),a(x,wi),p(e,Ka,s),_(et,e,s),Qa=!0},p(e,[s]){const tt={};s&2&&(tt.$$scope={dirty:s,ctx:e}),J.$set(tt);const ta={};s&2&&(ta.$$scope={dirty:s,ctx:e}),fe.$set(ta)},i(e){Qa||(d(E.$$.fragment,e),d(J.$$.fragment,e),d(De.$$.fragment,e),d(xe.$$.fragment,e),d(Ae.$$.fragment,e),d(Se.$$.fragment,e),d(je.$$.fragment,e),d(Ie.$$.fragment,e),d(Ne.$$.fragment,e),d(Ce.$$.fragment,e),d(Re.$$.fragment,e),d(Ue.$$.fragment,e),d(Oe.$$.fragment,e),d(Me.$$.fragment,e),d(Le.$$.fragment,e),d(Ge.$$.fragment,e),d(Be.$$.fragment,e),d(Ve.$$.fragment,e),d(He.$$.fragment,e),d(Ye.$$.fragment,e),d(fe.$$.fragment,e),d(We.$$.fragment,e),d(Je.$$.fragment,e),d(Qe.$$.fragment,e),d(Xe.$$.fragment,e),d(et.$$.fragment,e),Qa=!0)},o(e){g(E.$$.fragment,e),g(J.$$.fragment,e),g(De.$$.fragment,e),g(xe.$$.fragment,e),g(Ae.$$.fragment,e),g(Se.$$.fragment,e),g(je.$$.fragment,e),g(Ie.$$.fragment,e),g(Ne.$$.fragment,e),g(Ce.$$.fragment,e),g(Re.$$.fragment,e),g(Ue.$$.fragment,e),g(Oe.$$.fragment,e),g(Me.$$.fragment,e),g(Le.$$.fragment,e),g(Ge.$$.fragment,e),g(Be.$$.fragment,e),g(Ve.$$.fragment,e),g(He.$$.fragment,e),g(Ye.$$.fragment,e),g(fe.$$.fragment,e),g(We.$$.fragment,e),g(Je.$$.fragment,e),g(Qe.$$.fragment,e),g(Xe.$$.fragment,e),g(et.$$.fragment,e),Qa=!1},d(e){t(b),e&&t($),e&&t(w),v(E),e&&t(aa),e&&t(we),e&&t(sa),e&&t(F),e&&t(oa),e&&t(W),e&&t(ia),v(J,e),e&&t(ra),e&&t(C),v(De),e&&t(na),e&&t(R),v(xe),e&&t(la),e&&t(T),e&&t(pa),v(Ae,e),e&&t(ha),e&&t(Q),e&&t(ca),v(Se,e),e&&t(fa),e&&t(j),e&&t(ua),e&&t(X),e&&t(ma),e&&t(U),v(je),e&&t(_a),e&&t(te),e&&t(da),e&&t(ot),e&&t(ga),v(Ie,e),e&&t(va),e&&t(O),v(Ne),e&&t(ba),e&&t(it),e&&t(wa),e&&t(se),e&&t($a),v(Ce,e),e&&t(Ea),e&&t(M),v(Re),e&&t(ya),e&&t(rt),e&&t(ka),v(Ue,e),e&&t(Da),e&&t(k),e&&t(xa),e&&t(L),v(Oe),e&&t(Aa),e&&t(q),e&&t(Pa),v(Me,e),e&&t(Sa),e&&t(nt),e&&t(Ta),e&&t(G),v(Le),e&&t(ja),e&&t(lt),e&&t(qa),e&&t(pt),e&&t(Ia),v(Ge,e),e&&t(Na),e&&t(B),v(Be),e&&t(Ca),e&&t(le),e&&t(Ra),v(Ve,e),e&&t(Ua),e&&t(pe),e&&t(Oa),v(He,e),e&&t(Ma),e&&t(z),v(Ye),e&&t(La),e&&t(D),e&&t(Ga),e&&t(ce),e&&t(Ba),v(fe,e),e&&t(za),v(We,e),e&&t(Va),e&&t(V),v(Je),e&&t(Ha),e&&t(me),e&&t(Ya),e&&t(I),e&&t(Fa),e&&t(_e),e&&t(Wa),v(Qe,e),e&&t(Ja),e&&t(H),v(Xe),e&&t(Za),e&&t(x),e&&t(Ka),v(et,e)}}}const Jr={local:"dreambooth-finetuning-example",sections:[{local:"training-locally",sections:[{local:"installing-the-dependencies",title:"Installing the dependencies"},{local:"dog-toy-example",title:"Dog toy example"},{local:"training-with-a-priorpreserving-loss",title:"Training with a prior-preserving loss"},{local:"saving-checkpoints-while-training",sections:[{local:"resuming-training-from-a-saved-checkpoint",title:"Resuming training from a saved checkpoint"},{local:"performing-inference-using-a-saved-checkpoint",title:"Performing inference using a saved checkpoint"}],title:"Saving checkpoints while training"},{local:"training-on-a-16gb-gpu",title:"Training on a 16GB GPU"},{local:"finetune-the-text-encoder-in-addition-to-the-unet",title:"Fine-tune the text encoder in addition to the UNet"},{local:"training-on-a-8-gb-gpu",title:"Training on a 8 GB GPU:"}],title:"Training locally "},{local:"inference",title:"Inference"}],title:"DreamBooth fine-tuning example"};function Zr(at){return Hr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class tn extends Lr{constructor(b){super();Gr(this,b,Zr,Wr,Br,{})}}export{tn as default,Jr as metadata};
